#include <windows.h>
#include <stdio.h>
#include "proc.h"

LRESULT CALLBACK WndProc
     ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );


int WINAPI WinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance,
                   LPSTR lpszCmdParam, int nCmdShow)

{ HWND hWnd;
  WNDCLASS WndClass;
  MSG Msg;
  char szClassName[] = "Processed";

  /*    */
  WndClass.style = CS_HREDRAW | CS_VREDRAW;
  WndClass.lpfnWndProc = WndProc;
  WndClass.cbClsExtra = 0; WndClass.cbWndExtra = 0;
  WndClass.hInstance = hInstance;
  WndClass.hIcon   = LoadIcon(NULL,IDI_APPLICATION);
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);
  WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
  WndClass.lpszMenuName = "PROC_MENU";
  WndClass.lpszClassName = szClassName;
  /*    */
  if (! RegisterClass(&WndClass) )
  { MessageBox(NULL,"Cannot register class","Error",MB_OK);
    return 1;  }
  /*   */
  hWnd = CreateWindow(szClassName,
  		     "Process Demo",
                      WS_OVERLAPPEDWINDOW,
                      CW_USEDEFAULT, CW_USEDEFAULT,
                      CW_USEDEFAULT, CW_USEDEFAULT,
                      NULL, NULL, hInstance, NULL);
 if (!hWnd)
 { MessageBox(NULL,"Cannot create Window","Error",MB_OK);
   return 2; }
 ShowWindow(hWnd,nCmdShow);
 UpdateWindow(hWnd);
 /*       WM_QUIT */
 while (GetMessage(&Msg, NULL, 0,0))
 { TranslateMessage(&Msg); //     
  DispatchMessage(&Msg);  //  
 }
 return Msg.wParam; //   ,   WM_QUIT
}

/*   */
LRESULT CALLBACK WndProc ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam )
{ const Max = 10;
  STARTUPINFO StartupInfo;
  static int ProcessNumber = 0;
  static PROCESS_INFORMATION ProcessInformation[Max];
  static char cMyMessage[80];
  static HMENU hMenu;

  switch (Message)
  { case WM_CREATE  :
        hMenu = GetMenu(hWnd);
        return 0;

   case WM_COMMAND :
       switch (LOWORD(wParam))
       { case IDM_NEW:
         if (ProcessNumber<Max)
         {
           StartupInfo.cb = sizeof(STARTUPINFO);
           StartupInfo.lpReserved = NULL;
           StartupInfo.lpDesktop = NULL;
           StartupInfo.lpTitle = NULL;
           StartupInfo.dwFlags = STARTF_USESHOWWINDOW;
           StartupInfo.wShowWindow = SW_SHOWNORMAL;
           StartupInfo.cbReserved2 = 0;
           StartupInfo.lpReserved2 = NULL;
           if (CreateProcess(NULL,"notepad.exe",NULL,NULL,FALSE,0,NULL,NULL,&StartupInfo,
               &(ProcessInformation[ProcessNumber])))
           { ProcessNumber++;
             wsprintf(cMyMessage,"hProcess is %x.\nhThread is %x,\ndwProcessId is %x.\ndwThreadId is %x.",
             ProcessInformation[ProcessNumber-1].hProcess,
             ProcessInformation[ProcessNumber-1].hThread,
             ProcessInformation[ProcessNumber-1].dwProcessId,
             ProcessInformation[ProcessNumber-1].dwThreadId);
             EnableMenuItem(hMenu,IDM_KILL,MF_BYCOMMAND | MF_ENABLED);
             MessageBox(hWnd,cMyMessage,"Process is created",MB_OK | MB_ICONASTERISK);
           }
           else MessageBox(hWnd,"Too many created processes","Process creation",MB_ICONHAND | MB_OK);
         }
         break;
         case IDM_KILL:
         if (ProcessNumber>0)
         { if (TerminateProcess(ProcessInformation[ProcessNumber-1].hProcess,0))
           { ProcessNumber--;
             if(!ProcessNumber) EnableMenuItem(hMenu,IDM_KILL,MF_BYCOMMAND | MF_GRAYED);
           }
           else MessageBox(hWnd,"Cannot terminate process","Process termination",MB_OK);
         }
         else MessageBox(hWnd,"No more processes","Process termination",MB_OK);
         break;
         case IDM_EXIT:
         SendMessage(hWnd,WM_CLOSE,0,0);
         break;

       }
      return 0;

   case WM_DESTROY :
      PostQuitMessage(0);
      return 0;

   default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}